/*
 * Created on Jan 30, 2005
 */
package towerHw3.tmodel;

import java.util.ArrayList;
import java.util.List;

import mvc373Hw3.ITowerModel;

/**  Test implementation for a Tower of Hanoi Game model.
 */
public class TowerModel implements ITowerModel {
    
    public static final String AUTHOR = "Martin D.";
    public static final String SHORT_DESCRIPTION = "a stub";
    public static final String LONG_DESCRIPTION = "A simple, mostly incorrect " +
    				" version just for verifying that the pieces fit together.";

    private int[] towers;  //stub implementation with just counts
    
    private int towerCount;
    private int discCount;
    
    /** Required constructor.
     *
     */
    public TowerModel() {
        
    }

    /*  
     * @see tower.ITowerModel#start(int, int)
     */
    public boolean start(int towerCount, int discCount) {
        if (towerCount <1) {
            throw new IllegalArgumentException("towerCount must be >= 1, " +
                    " cannot be " + towerCount);
        }
        if (discCount <1) {
            throw new IllegalArgumentException("discCount must be >= 1, " +
                    " cannot be " + discCount);
        }
        this.towerCount = towerCount;
        this.towers = new int[towerCount];
        this.discCount = discCount;
        return true;
    }

    /* 
     * @see tower.ITowerModel#move(int, int)
     */
    public boolean move(int fromTower, int toTower) {
        if (fromTower >= this.towerCount) {
            throw new IllegalArgumentException("Tower num for move from can't be " +
                    fromTower);
        }
        if (toTower >= this.towerCount) {
            throw new IllegalArgumentException("Tower num fro move to can't be " +
                    toTower);
        }
        this.towers[fromTower]--;
        this.towers[toTower]++;
        return false;
    }

    /* 
     * @see tower.ITowerModel#getDiskList(int)
     */
    public List getDiskList(int tower) {
        if (tower >= this.towerCount) {
            throw new IllegalArgumentException("Tower num for get from can't be " +
                    tower);
        }
        List diskList = new ArrayList();
        for (int d = this.towers[tower]; d > 0; d--) {
            diskList.add(new Integer(d));
        }
        //stub
        return null;
    }

    /* 
     * @see tower.ITowerModel#getTowerCount()
     */
    public int getTowerCount() {
        return this.towerCount;
    }

    /* 
     * @see tower.ITowerModel#backup()
     */
    public boolean backup() {
        return false;
    }

}
